import { Component, OnInit } from '@angular/core';
import { BreadcrumbService } from '../../commons/service/breadcrumb.service';


@Component({
  selector: 'of-page-notification',
  templateUrl: './notification-page.component.html',
})
export class NotificationPageComponent implements OnInit {

  constructor(
    private breadcrumbService: BreadcrumbService
  ) {
    breadcrumbService.setItems([
      { label: 'Notifications', routerLink: ['/notification'] },
    ]);
  }

  ngOnInit() {
  }

}
