import { RPCClientError } from '@loafer/ng-rpc';
import { Page } from '@overflow/commons-typescript/model/commons/Page';
import { Notification } from '@overflow/commons-typescript/model/notification';

export interface State {
  error: RPCClientError | null;
  page: Page<Notification> | null;
}

export const initialState: State = {
  error: null,
  page: null,
};
