import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { SensorModule } from '@overflow/sensor/sensor.module';
import { SensorPageRoutingModule } from './sensor-page-routing.module';
import { SensorPageComponent } from './sensor-page.component';
import { TabbarModule } from '../../commons/component/layout/tabbar/app.tabbar.module';

@NgModule({
  imports: [
    CommonModule,
    SensorPageRoutingModule,
    SensorModule,
    TabbarModule
  ],
  declarations: [
    SensorPageComponent,
  ]
})
export class SensorPageModule { }
